diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/examples/wireless/wifi-multirate.cc ns-3.36/examples/wireless/wifi-multirate.cc
--- ns-3.35/examples/wireless/wifi-multirate.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/examples/wireless/wifi-multirate.cc	2022-04-30 18:23:57.726733000 -0700
@@ -16,38 +16,6 @@
  * Author: Duy Nguyen <duy@soe.ucsc.edu>
  */
 
-/**
- * Scenarios: 100 nodes, multiple simultaneous flows, multi-hop ad hoc, routing,
- * and mobility
- *
- * QUICK INSTRUCTIONS:
- *
- * To optimize build:
- * ./waf -d optimized configure
- * ./waf
- *
- * To compile:
- * ./waf --run wifi-multirate
- *
- * To compile with command line(useful for varying parameters):
- * ./waf --run "wifi-multirate --totalTime=0.3s --rateManager=ns3::MinstrelWifiManager"
- *
- * To turn on NS_LOG:
- * export NS_LOG=multirate=level_all
- * (can only view log if built with ./waf -d debug configure)
- *
- * To debug:
- * ./waf --shell
- * gdb ./build/debug/examples/wireless/wifi-multirate
- *
- * To view pcap files:
- * tcpdump -nn -tt -r filename.pcap
- *
- * To monitor the files:
- * tail -f filename.pcap
- *
- */
-
 #include "ns3/gnuplot.h"
 #include "ns3/command-line.h"
 #include "ns3/config.h"
@@ -73,74 +41,218 @@
 
 NS_LOG_COMPONENT_DEFINE ("multirate");
 
+/**
+ * WiFi multirate experiment class.
+ * 
+ * It handles the creation and run of an experiment.
+ *
+ * Scenarios: 100 nodes, multiple simultaneous flows, multi-hop ad hoc, routing,
+ * and mobility
+ *
+ * QUICK INSTRUCTIONS:
+ *
+ * To optimize build:
+ * ./ns3 configure -d optimized
+ * ./ns3
+ *
+ * To compile:
+ * ./ns3 run wifi-multirate
+ *
+ * To compile with command line(useful for varying parameters):
+ * ./ns3 run "wifi-multirate --totalTime=0.3s --rateManager=ns3::MinstrelWifiManager"
+ *
+ * To turn on NS_LOG:
+ * export NS_LOG=multirate=level_all
+ * (can only view log if built with ./ns3 configure -d debug)
+ *
+ * To debug:
+ * ./ns3 shell
+ * gdb ./build/debug/examples/wireless/wifi-multirate
+ *
+ * To view pcap files:
+ * tcpdump -nn -tt -r filename.pcap
+ *
+ * To monitor the files:
+ * tail -f filename.pcap
+ *
+ */
 class Experiment
 {
 public:
   Experiment ();
+  /**
+   * \brief Construct a new Experiment object
+   * 
+   * \param name The name of the experiment.
+   */
   Experiment (std::string name);
+  /**
+   * Run an experiment.
+   * \param wifi The WifiHelper class.
+   * \param wifiPhy The YansWifiPhyHelper class.
+   * \param wifiMac The WifiMacHelper class.
+   * \param wifiChannel The YansWifiChannelHelper class.
+   * \param mobility The MobilityHelper class.
+   * \return a 2D dataset of the experiment data. 
+   */
   Gnuplot2dDataset Run (const WifiHelper &wifi, const YansWifiPhyHelper &wifiPhy,
                         const WifiMacHelper &wifiMac, const YansWifiChannelHelper &wifiChannel, const MobilityHelper &mobility);
 
+  /**
+   * \brief Setup the experiment from the command line arguments.
+   * 
+   * \param argc The argument count.
+   * \param argv The argument vector.
+   * \return true 
+   */
   bool CommandSetup (int argc, char **argv);
+
+  /**
+   * \brief Check if routing is enabled.
+   * 
+   * \return true if routing is enabled.
+   */
   bool IsRouting ()
   {
-    return (enableRouting == 1) ? 1 : 0;
+    return (m_enableRouting == 1) ? 1 : 0;
   }
+  /**
+   * \brief Check if mobility is enabled.
+   * 
+   * \return true if mobility is enabled.
+   */
   bool IsMobility ()
   {
-    return (enableMobility == 1) ? 1 : 0;
+    return (m_enableMobility == 1) ? 1 : 0;
   }
 
+  /**
+   * \brief Get the Scenario number.
+   * 
+   * \return the scenario number. 
+   */
   uint32_t GetScenario ()
   {
-    return scenario;
+    return m_scenario;
   }
-
+  /**
+   * \brief Get the RTS Threshold.
+   * 
+   * \return the RTS Threshold.
+   */
   std::string GetRtsThreshold ()
   {
-    return rtsThreshold;
+    return m_rtsThreshold;
   }
+  /**
+   * \brief Get the Output File Name.
+   * 
+   * \return the Output File Name. 
+   */
   std::string GetOutputFileName ()
   {
-    return outputFileName;
+    return m_outputFileName;
   }
+  /**
+   * \brief Get the Rate Manager.
+   * 
+   * \return the Rate Manager.
+   */
   std::string GetRateManager ()
   {
-    return rateManager;
+    return m_rateManager;
   }
 
 private:
+  /**
+   * \brief Setup the receiving socket.
+   * 
+   * \param node The receiving node.
+   * \return the Rx socket.
+   */
   Ptr<Socket> SetupPacketReceive (Ptr<Node> node);
+  /**
+   * Generate 1-hop and 2-hop neighbors of a node in grid topology
+   * \param c The node container.
+   * \param senderId The sender ID.
+   * \return the neighbor nodes.
+   */
   NodeContainer GenerateNeighbors (NodeContainer c, uint32_t senderId);
 
+  /**
+   * \brief Setup the application in the nodes.
+   * 
+   * \param client Client node.
+   * \param server Server node.
+   * \param start Start time.
+   * \param stop Stop time.
+   */
   void ApplicationSetup (Ptr<Node> client, Ptr<Node> server, double start, double stop);
+  /**
+   * Take the grid map, divide it into 4 quadrants
+   * Assign all nodes from each quadrant to a specific container
+   *
+   * \param c The node container.
+   */
   void AssignNeighbors (NodeContainer c);
+  /**
+   * Sources and destinations are randomly selected such that a node
+   * may be the source for multiple destinations and a node maybe a destination
+   * for multiple sources.
+   * 
+   * \param c The node container.
+   */
   void SelectSrcDest (NodeContainer c);
+  /**
+   * \brief Receive a packet.
+   * 
+   * \param socket The receiving socket.
+   */
   void ReceivePacket (Ptr<Socket> socket);
+  /**
+   * \brief Calculate the throughput.
+   */
   void CheckThroughput ();
+  /**
+   * A sender node will  set up a flow to each of the its neighbors
+   * in its quadrant randomly.  All the flows are exponentially distributed.
+   * 
+   * \param sender The sender node.
+   * \param c The node neighbors.
+   */
   void SendMultiDestinations (Ptr<Node> sender, NodeContainer c);
 
-  Gnuplot2dDataset m_output;
+  Gnuplot2dDataset m_output;  //!< Output dataset.
 
-  double totalTime;
-  double expMean;
-  double samplingPeriod;
-
-  uint32_t bytesTotal;
-  uint32_t packetSize;
-  uint32_t gridSize;
-  uint32_t nodeDistance;
-  uint32_t port;
-  uint32_t scenario;
-
-  bool enablePcap;
-  bool enableTracing;
-  bool enableFlowMon;
-  bool enableRouting;
-  bool enableMobility;
-
-  NodeContainer containerA, containerB, containerC, containerD;
-  std::string rtsThreshold, rateManager, outputFileName;
+  double m_totalTime;       //!< Total experiment time.
+  double m_expMean;         //!< Exponential parameter for sending packets.
+  double m_samplingPeriod;  //!< Sampling period.
+
+  uint32_t m_bytesTotal;    //!< Total number of received bytes.
+  uint32_t m_packetSize;    //!< Packet size.
+  uint32_t m_gridSize;      //!< Grid size.
+  uint32_t m_nodeDistance;  //!< Node distance.
+  uint32_t m_port;          //!< Listening port.
+  uint32_t m_scenario;      //!< Scnario number.
+
+  bool m_enablePcap;        //!< True if PCAP output is enabled.
+  bool m_enableTracing;     //!< True if tracing output is enabled.
+  bool m_enableFlowMon;     //!< True if FlowMon is enabled.
+  bool m_enableRouting;     //!< True if routing is enabled.
+  bool m_enableMobility;    //!< True if mobility is enabled.
+
+  /**
+   * Node containers for each quadrant.
+   * @{
+   */
+  NodeContainer m_containerA;
+  NodeContainer m_containerB;
+  NodeContainer m_containerC;
+  NodeContainer m_containerD;
+  /** @} */
+  std::string m_rtsThreshold; //!< Rts threshold.
+  std::string m_rateManager;  //!< Rate manager.
+  std::string m_outputFileName; //!< Output file name.
 };
 
 Experiment::Experiment ()
@@ -149,26 +261,26 @@
 
 Experiment::Experiment (std::string name)
   : m_output (name),
-    totalTime (0.3),
-    expMean (0.1),
+    m_totalTime (0.3),
+    m_expMean (0.1),
     //flows being exponentially distributed
-    samplingPeriod (0.1),
-    bytesTotal (0),
-    packetSize (2000),
-    gridSize (10),
+    m_samplingPeriod (0.1),
+    m_bytesTotal (0),
+    m_packetSize (2000),
+    m_gridSize (10),
     //10x10 grid  for a total of 100 nodes
-    nodeDistance (30),
-    port (5000),
-    scenario (4),
-    enablePcap (false),
-    enableTracing (true),
-    enableFlowMon (false),
-    enableRouting (false),
-    enableMobility (false),
-    rtsThreshold ("2200"),
+    m_nodeDistance (30),
+    m_port (5000),
+    m_scenario (4),
+    m_enablePcap (false),
+    m_enableTracing (true),
+    m_enableFlowMon (false),
+    m_enableRouting (false),
+    m_enableMobility (false),
+    m_rtsThreshold ("2200"),
     //0 for enabling rts/cts
-    rateManager ("ns3::MinstrelWifiManager"),
-    outputFileName ("minstrel")
+    m_rateManager ("ns3::MinstrelWifiManager"),
+    m_outputFileName ("minstrel")
 {
   m_output.SetStyle (Gnuplot2dDataset::LINES);
 }
@@ -178,7 +290,7 @@
 {
   TypeId tid = TypeId::LookupByName ("ns3::UdpSocketFactory");
   Ptr<Socket> sink = Socket::CreateSocket (node, tid);
-  InetSocketAddress local = InetSocketAddress (Ipv4Address::GetAny (), port);
+  InetSocketAddress local = InetSocketAddress (Ipv4Address::GetAny (), m_port);
   sink->Bind (local);
   sink->SetRecvCallback (MakeCallback (&Experiment::ReceivePacket, this));
 
@@ -191,68 +303,58 @@
   Ptr<Packet> packet;
   while ((packet = socket->Recv ()))
     {
-      bytesTotal += packet->GetSize ();
+      m_bytesTotal += packet->GetSize ();
     }
 }
 
 void
 Experiment::CheckThroughput ()
 {
-  double mbs = ((bytesTotal * 8.0) / 1000000 / samplingPeriod);
-  bytesTotal = 0;
+  double mbs = ((m_bytesTotal * 8.0) / 1000000 / m_samplingPeriod);
+  m_bytesTotal = 0;
   m_output.Add ((Simulator::Now ()).GetSeconds (), mbs);
 
   //check throughput every samplingPeriod second
-  Simulator::Schedule (Seconds (samplingPeriod), &Experiment::CheckThroughput, this);
+  Simulator::Schedule (Seconds (m_samplingPeriod), &Experiment::CheckThroughput, this);
 }
 
-/**
- *
- * Take the grid map, divide it into 4 quadrants
- * Assign all nodes from each quadrant to a specific container
- *
- */
 void
 Experiment::AssignNeighbors (NodeContainer c)
 {
   uint32_t totalNodes = c.GetN ();
   for (uint32_t i = 0; i < totalNodes; i++)
     {
-      if ( (i % gridSize) <= (gridSize / 2 - 1))
+      if ( (i % m_gridSize) <= (m_gridSize / 2 - 1))
         {
           //lower left quadrant
           if ( i < totalNodes / 2 )
             {
-              containerA.Add (c.Get (i));
+              m_containerA.Add (c.Get (i));
             }
 
           //upper left quadrant
           if ( i >= (uint32_t)(4 * totalNodes) / 10 )
             {
-              containerC.Add (c.Get (i));
+              m_containerC.Add (c.Get (i));
             }
         }
-      if ( (i % gridSize) >= (gridSize / 2 - 1))
+      if ( (i % m_gridSize) >= (m_gridSize / 2 - 1))
         {
           //lower right quadrant
           if ( i < totalNodes / 2 )
             {
-              containerB.Add (c.Get (i));
+              m_containerB.Add (c.Get (i));
             }
 
           //upper right quadrant
           if ( i >= (uint32_t)(4 * totalNodes) / 10  )
             {
-              containerD.Add (c.Get (i));
+              m_containerD.Add (c.Get (i));
             }
         }
     }
 }
 
-/**
- * Generate 1-hop and 2-hop neighbors of a node in grid topology
- *
- */
 NodeContainer
 Experiment::GenerateNeighbors (NodeContainer c, uint32_t senderId)
 {
@@ -270,11 +372,6 @@
   return nc;
 }
 
-/**
- * Sources and destinations are randomly selected such that a node
- * may be the source for multiple destinations and a node maybe a destination
- * for multiple sources.
- */
 void
 Experiment::SelectSrcDest (NodeContainer c)
 {
@@ -288,16 +385,10 @@
 
   for (uint32_t i = 0; i < totalNodes / 3; i++)
     {
-      ApplicationSetup (c.Get (uvSrc->GetInteger ()), c.Get (uvDest->GetInteger ()),  0, totalTime);
+      ApplicationSetup (c.Get (uvSrc->GetInteger ()), c.Get (uvDest->GetInteger ()),  0, m_totalTime);
     }
 }
 
-/**
- *
- * A sender node will  set up a flow to each of the its neighbors
- * in its quadrant randomly.  All the flows are exponentially distributed
- *
- */
 void
 Experiment::SendMultiDestinations (Ptr<Node> sender, NodeContainer c)
 {
@@ -309,8 +400,8 @@
 
   // ExponentialRandomVariable params: (mean, upperbound)
   Ptr<ExponentialRandomVariable> ev = CreateObject<ExponentialRandomVariable> ();
-  ev->SetAttribute ("Mean", DoubleValue (expMean));
-  ev->SetAttribute ("Bound", DoubleValue (totalTime));
+  ev->SetAttribute ("Mean", DoubleValue (m_expMean));
+  ev->SetAttribute ("Bound", DoubleValue (m_totalTime));
 
   double start = 0.0, stop;
   uint32_t destIndex;
@@ -330,7 +421,7 @@
 
       start = stop;
 
-      if (start > totalTime)
+      if (start > m_totalTime)
         {
           break;
         }
@@ -382,10 +473,10 @@
   NS_LOG_DEBUG (PrintPosition (client, server));
 
   // Equipping the source  node with OnOff Application used for sending
-  OnOffHelper onoff ("ns3::UdpSocketFactory", Address (InetSocketAddress (Ipv4Address ("10.0.0.1"), port)));
+  OnOffHelper onoff ("ns3::UdpSocketFactory", Address (InetSocketAddress (Ipv4Address ("10.0.0.1"), m_port)));
   onoff.SetConstantRate (DataRate (60000000));
-  onoff.SetAttribute ("PacketSize", UintegerValue (packetSize));
-  onoff.SetAttribute ("Remote", AddressValue (InetSocketAddress (ipv4AddrServer, port)));
+  onoff.SetAttribute ("PacketSize", UintegerValue (m_packetSize));
+  onoff.SetAttribute ("Remote", AddressValue (InetSocketAddress (ipv4AddrServer, m_port)));
 
   ApplicationContainer apps = onoff.Install (client);
   apps.Start (Seconds (start));
@@ -401,7 +492,7 @@
 {
 
 
-  uint32_t nodeSize = gridSize * gridSize;
+  uint32_t nodeSize = m_gridSize * m_gridSize;
   NodeContainer c;
   c.Create (nodeSize);
 
@@ -417,7 +508,7 @@
 
   Ipv4ListRoutingHelper list;
 
-  if (enableRouting)
+  if (m_enableRouting)
     {
       list.Add (staticRouting, 0);
       list.Add (olsr, 10);
@@ -425,7 +516,7 @@
 
   InternetStackHelper internet;
 
-  if (enableRouting)
+  if (m_enableRouting)
     {
       internet.SetRoutingHelper (list);  // has effect on the next Install ()
     }
@@ -442,14 +533,14 @@
   mobil.SetPositionAllocator ("ns3::GridPositionAllocator",
                               "MinX", DoubleValue (0.0),
                               "MinY", DoubleValue (0.0),
-                              "DeltaX", DoubleValue (nodeDistance),
-                              "DeltaY", DoubleValue (nodeDistance),
-                              "GridWidth", UintegerValue (gridSize),
+                              "DeltaX", DoubleValue (m_nodeDistance),
+                              "DeltaY", DoubleValue (m_nodeDistance),
+                              "GridWidth", UintegerValue (m_gridSize),
                               "LayoutType", StringValue ("RowFirst"));
 
   mobil.SetMobilityModel ("ns3::ConstantPositionMobilityModel");
 
-  if (enableMobility && enableRouting)
+  if (m_enableMobility && m_enableRouting)
     {
       //Rectangle (xMin, xMax, yMin, yMax)
       mobil.SetMobilityModel ("ns3::RandomDirection2dMobilityModel",
@@ -459,37 +550,37 @@
     }
   mobil.Install (c);
 
-  if ( scenario == 1 && enableRouting)
+  if ( m_scenario == 1 && m_enableRouting)
     {
       SelectSrcDest (c);
     }
-  else if ( scenario == 2)
+  else if ( m_scenario == 2)
     {
       //All flows begin at the same time
       for (uint32_t i = 0; i < nodeSize - 1; i = i + 2)
         {
-          ApplicationSetup (c.Get (i), c.Get (i + 1),  0, totalTime);
+          ApplicationSetup (c.Get (i), c.Get (i + 1),  0, m_totalTime);
         }
     }
-  else if ( scenario == 3)
+  else if ( m_scenario == 3)
     {
       AssignNeighbors (c);
       //Note: these senders are hand-picked in order to ensure good coverage
       //for 10x10 grid, basically one sender for each quadrant
       //you might have to change these values for other grids
       NS_LOG_DEBUG (">>>>>>>>>region A<<<<<<<<<");
-      SendMultiDestinations (c.Get (22), containerA);
+      SendMultiDestinations (c.Get (22), m_containerA);
 
       NS_LOG_DEBUG (">>>>>>>>>region B<<<<<<<<<");
-      SendMultiDestinations (c.Get (26), containerB);
+      SendMultiDestinations (c.Get (26), m_containerB);
 
       NS_LOG_DEBUG (">>>>>>>>>region C<<<<<<<<<");
-      SendMultiDestinations (c.Get (72), containerC);
+      SendMultiDestinations (c.Get (72), m_containerC);
 
       NS_LOG_DEBUG (">>>>>>>>>region D<<<<<<<<<");
-      SendMultiDestinations (c.Get (76), containerD);
+      SendMultiDestinations (c.Get (76), m_containerD);
     }
-  else if ( scenario == 4)
+  else if ( m_scenario == 4)
     {
       //GenerateNeighbors(NodeContainer, uint32_t sender)
       //Note: these senders are hand-picked in order to ensure good coverage
@@ -519,13 +610,13 @@
 
   CheckThroughput ();
 
-  if (enablePcap)
+  if (m_enablePcap)
     {
       phy.SetPcapDataLinkType (WifiPhyHelper::DLT_IEEE802_11_RADIO);
       phy.EnablePcapAll (GetOutputFileName ());
     }
 
-  if (enableTracing)
+  if (m_enableTracing)
     {
       AsciiTraceHelper ascii;
       phy.EnableAsciiAll (ascii.CreateFileStream (GetOutputFileName () + ".tr"));
@@ -533,15 +624,15 @@
 
   FlowMonitorHelper flowmonHelper;
 
-  if (enableFlowMon)
+  if (m_enableFlowMon)
     {
       flowmonHelper.InstallAll ();
     }
 
-  Simulator::Stop (Seconds (totalTime));
+  Simulator::Stop (Seconds (m_totalTime));
   Simulator::Run ();
 
-  if (enableFlowMon)
+  if (m_enableFlowMon)
     {
       flowmonHelper.SerializeToXmlFile ((GetOutputFileName () + ".flomon"), false, false);
     }
@@ -556,25 +647,25 @@
 {
   // for commandline input
   CommandLine cmd (__FILE__);
-  cmd.AddValue ("packetSize", "packet size", packetSize);
-  cmd.AddValue ("totalTime", "simulation time", totalTime);
+  cmd.AddValue ("packetSize", "packet size", m_packetSize);
+  cmd.AddValue ("totalTime", "simulation time", m_totalTime);
   // according to totalTime, select an appropriate samplingPeriod automatically.
-  if (totalTime < 1.0)
+  if (m_totalTime < 1.0)
     {
-      samplingPeriod = 0.1;
+      m_samplingPeriod = 0.1;
     }
   else
     {
-      samplingPeriod = 1.0;
+      m_samplingPeriod = 1.0;
     }
   // or user selects a samplingPeriod.
-  cmd.AddValue ("samplingPeriod", "sampling period", samplingPeriod);
-  cmd.AddValue ("rtsThreshold", "rts threshold", rtsThreshold);
-  cmd.AddValue ("rateManager", "type of rate", rateManager);
-  cmd.AddValue ("outputFileName", "output filename", outputFileName);
-  cmd.AddValue ("enableRouting", "enable Routing", enableRouting);
-  cmd.AddValue ("enableMobility", "enable Mobility", enableMobility);
-  cmd.AddValue ("scenario", "scenario ", scenario);
+  cmd.AddValue ("samplingPeriod", "sampling period", m_samplingPeriod);
+  cmd.AddValue ("rtsThreshold", "rts threshold", m_rtsThreshold);
+  cmd.AddValue ("rateManager", "type of rate", m_rateManager);
+  cmd.AddValue ("outputFileName", "output filename", m_outputFileName);
+  cmd.AddValue ("enableRouting", "enable Routing", m_enableRouting);
+  cmd.AddValue ("enableMobility", "enable Mobility", m_enableMobility);
+  cmd.AddValue ("scenario", "scenario ", m_scenario);
 
   cmd.Parse (argc, argv);
   return true;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/examples/wireless/wifi-multi-tos.cc ns-3.36/examples/wireless/wifi-multi-tos.cc
--- ns-3.35/examples/wireless/wifi-multi-tos.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/examples/wireless/wifi-multi-tos.cc	2022-04-30 18:23:57.726733000 -0700
@@ -76,7 +76,7 @@
 
   WifiMacHelper mac;
   WifiHelper wifi;
-  wifi.SetStandard (WIFI_STANDARD_80211n_5GHZ);
+  wifi.SetStandard (WIFI_STANDARD_80211n);
 
   std::ostringstream oss;
   oss << "HtMcs" << mcs;
@@ -100,7 +100,8 @@
   apDevice = wifi.Install (phy, mac, wifiApNode);
 
   // Set channel width
-  Config::Set ("/NodeList/*/DeviceList/*/$ns3::WifiNetDevice/Phy/ChannelWidth", UintegerValue (channelWidth));
+  Config::Set ("/NodeList/*/DeviceList/*/$ns3::WifiNetDevice/Phy/ChannelSettings",
+               StringValue ("{0, " + std::to_string (channelWidth) + ", BAND_2_4GHZ, 0}"));
 
   // Set guard interval
   Config::Set ("/NodeList/*/DeviceList/*/$ns3::WifiNetDevice/HtConfiguration/ShortGuardIntervalSupported", BooleanValue (useShortGuardInterval));
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/examples/wireless/wifi-power-adaptation-distance.cc ns-3.36/examples/wireless/wifi-power-adaptation-distance.cc
--- ns-3.35/examples/wireless/wifi-power-adaptation-distance.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/examples/wireless/wifi-power-adaptation-distance.cc	2022-04-30 18:23:57.726733000 -0700
@@ -66,17 +66,17 @@
  *
  * To display all the possible arguments and their defaults:
  * \code{.sh}
- *   ./waf --run "wifi-power-adaptation-distance --help"
+ *   ./ns3 run "wifi-power-adaptation-distance --help"
  * \endcode
  *
  * Example usage (selecting Aparf rather than Parf):
  * \code{.sh}
- *   ./waf --run "wifi-power-adaptation-distance --manager=ns3::AparfWifiManager --outputFileName=aparf"
+ *   ./ns3 run "wifi-power-adaptation-distance --manager=ns3::AparfWifiManager --outputFileName=aparf"
  * \endcode
  *
  * Another example (moving towards the AP):
  * \code{.sh}
- *   ./waf --run "wifi-power-adaptation-distance --manager=ns3::AparfWifiManager --outputFileName=aparf --stepsSize=-1 --STA1_x=200"
+ *   ./ns3 run "wifi-power-adaptation-distance --manager=ns3::AparfWifiManager --outputFileName=aparf --stepsSize=-1 --STA1_x=200"
  * \endcode
  *
  * To enable the log of rate and power changes:
@@ -109,40 +109,118 @@
 
 NS_LOG_COMPONENT_DEFINE ("PowerAdaptationDistance");
 
-//packet size generated at the AP
+/// Pcket size generated at the AP
 static const uint32_t packetSize = 1420;
 
+/**
+ * \brief Class to collect node statistics.
+ */
 class NodeStatistics
 {
 public:
+  /**
+   * \brief Constructor.
+   * 
+   * \param aps Access points
+   * \param stas WiFi Stations.
+   */
   NodeStatistics (NetDeviceContainer aps, NetDeviceContainer stas);
 
+  /**
+   * \brief Callback called by WifiNetDevice/Phy/PhyTxBegin. 
+   * 
+   * \param path The trace path.
+   * \param packet The sent packet.
+   * \param powerW The Tx power.
+   */
   void PhyCallback (std::string path, Ptr<const Packet> packet, double powerW);
+  /**
+   * \brief Callback called by PacketSink/Rx.
+   * 
+   * \param path The trace path.
+   * \param packet The received packet.
+   * \param from The sender address.
+   */
   void RxCallback (std::string path, Ptr<const Packet> packet, const Address &from);
+  /**
+   * \brief Callback called by WifiNetDevice/RemoteStationManager/x/PowerChange.
+   * 
+   * \param path The trace path.
+   * \param oldPower Old Tx power.
+   * \param newPower Actual Tx power.
+   * \param dest Destination of the transmission.
+   */
   void PowerCallback (std::string path, double oldPower, double newPower, Mac48Address dest);
+  /**
+   * \brief Callback called by WifiNetDevice/RemoteStationManager/x/RateChange.
+   * 
+   * \param path The trace path.
+   * \param oldRate Old rate.
+   * \param newRate Actual rate.
+   * \param dest Destination of the transmission.
+   */
   void RateCallback (std::string path, DataRate oldRate, DataRate newRate, Mac48Address dest);
+  /**
+   * \brief Set the Position of a node.
+   * 
+   * \param node The node.
+   * \param position The position.
+   */
   void SetPosition (Ptr<Node> node, Vector position);
+  /**
+   * Move a node.
+   * \param node The node.
+   * \param stepsSize The step size.
+   * \param stepsTime Time on each step.
+   */
   void AdvancePosition (Ptr<Node> node, int stepsSize, int stepsTime);
+  /**
+   * \brief Get the Position of a node.
+   * 
+   * \param node The node.
+   * \return the position of the node.
+   */
   Vector GetPosition (Ptr<Node> node);
 
+  /**
+   * \brief Get the Throughput output data
+   * 
+   * \return the Throughput output data.
+   */
   Gnuplot2dDataset GetDatafile ();
+  /**
+   * \brief Get the Power output data.
+   * 
+   * \return the Power output data.
+   */
   Gnuplot2dDataset GetPowerDatafile ();
 
 
 private:
+  /// Time, DataRate pair vector.
   typedef std::vector<std::pair<Time, DataRate> > TxTime;
+  /**
+   * \brief Setup the WifiPhy object.
+   * 
+   * \param phy The WifiPhy to setup.
+   */
   void SetupPhy (Ptr<WifiPhy> phy);
+  /**
+   * \brief Get the time at which a given datarate has been recorded.
+   * 
+   * \param rate The datarate to search.
+   * \return the time.
+   */
   Time GetCalcTxTime (DataRate rate);
 
-  std::map<Mac48Address, double> currentPower;
-  std::map<Mac48Address, DataRate> currentRate;
-  uint32_t m_bytesTotal;
-  double totalEnergy;
-  double totalTime;
-  Ptr<WifiPhy> myPhy;
-  TxTime timeTable;
-  Gnuplot2dDataset m_output;
-  Gnuplot2dDataset m_output_power;
+  std::map<Mac48Address, double> m_currentPower;  //!< Current Tx power for each sender.
+  std::map<Mac48Address, DataRate> m_currentRate; //!< Current Tx rate for each sender.
+  uint32_t m_bytesTotal;  //!< Number of received bytes on a given state.
+  double m_totalEnergy;   //!< Energy used on a given state.
+  double m_totalTime;     //!< Time spent on a given state.
+  TxTime m_timeTable;     //!< Time, DataRate table.
+  Gnuplot2dDataset m_output;  //!< Throughput output data.
+  Gnuplot2dDataset m_output_power;  //!< Power output data.
 };
 
 NodeStatistics::NodeStatistics (NetDeviceContainer aps, NetDeviceContainer stas)
@@ -150,7 +228,6 @@
   Ptr<NetDevice> device = aps.Get (0);
   Ptr<WifiNetDevice> wifiDevice = DynamicCast<WifiNetDevice> (device);
   Ptr<WifiPhy> phy = wifiDevice->GetPhy ();
-  myPhy = phy;
   SetupPhy (phy);
   DataRate dataRate = DataRate (phy->GetDefaultMode ().GetDataRate (phy->GetChannelWidth ()));
   double power = phy->GetTxPowerEnd ();
@@ -159,12 +236,12 @@
       Ptr<NetDevice> staDevice = stas.Get (j);
       Ptr<WifiNetDevice> wifiStaDevice = DynamicCast<WifiNetDevice> (staDevice);
       Mac48Address addr = wifiStaDevice->GetMac ()->GetAddress ();
-      currentPower[addr] = power;
-      currentRate[addr] = dataRate;
+      m_currentPower[addr] = power;
+      m_currentRate[addr] = dataRate;
     }
-  currentRate[Mac48Address ("ff:ff:ff:ff:ff:ff")] = dataRate;
-  totalEnergy = 0;
-  totalTime = 0;
+  m_currentRate[Mac48Address ("ff:ff:ff:ff:ff:ff")] = dataRate;
+  m_totalEnergy = 0;
+  m_totalTime = 0;
   m_bytesTotal = 0;
   m_output.SetTitle ("Throughput Mbits/s");
   m_output_power.SetTitle ("Average Transmit Power");
@@ -182,14 +259,14 @@
       DataRate dataRate = DataRate (mode.GetDataRate (phy->GetChannelWidth ()));
       Time time = phy->CalculateTxDuration (packetSize, txVector, phy->GetPhyBand ());
       NS_LOG_DEBUG (mode.GetUniqueName () << " " << time.GetSeconds () << " " << dataRate);
-      timeTable.push_back (std::make_pair (time, dataRate));
+      m_timeTable.push_back (std::make_pair (time, dataRate));
     }
 }
 
 Time
 NodeStatistics::GetCalcTxTime (DataRate rate)
 {
-  for (TxTime::const_iterator i = timeTable.begin (); i != timeTable.end (); i++)
+  for (TxTime::const_iterator i = m_timeTable.begin (); i != m_timeTable.end (); i++)
     {
       if (rate == i->second)
         {
@@ -209,21 +286,21 @@
 
   if (head.GetType () == WIFI_MAC_DATA)
     {
-      totalEnergy += pow (10.0, currentPower[dest] / 10.0) * GetCalcTxTime (currentRate[dest]).GetSeconds ();
-      totalTime += GetCalcTxTime (currentRate[dest]).GetSeconds ();
+      m_totalEnergy += pow (10.0, m_currentPower[dest] / 10.0) * GetCalcTxTime (m_currentRate[dest]).GetSeconds ();
+      m_totalTime += GetCalcTxTime (m_currentRate[dest]).GetSeconds ();
     }
 }
 
 void
 NodeStatistics::PowerCallback (std::string path, double oldPower, double newPower, Mac48Address dest)
 {
-  currentPower[dest] = newPower;
+  m_currentPower[dest] = newPower;
 }
 
 void
 NodeStatistics::RateCallback (std::string path, DataRate oldRate, DataRate newRate, Mac48Address dest)
 {
-  currentRate[dest] = newRate;
+  m_currentRate[dest] = newRate;
 }
 
 void
@@ -252,9 +329,9 @@
   Vector pos = GetPosition (node);
   double mbs = ((m_bytesTotal * 8.0) / (1000000 * stepsTime));
   m_bytesTotal = 0;
-  double atp = totalEnergy / stepsTime;
-  totalEnergy = 0;
-  totalTime = 0;
+  double atp = m_totalEnergy / stepsTime;
+  m_totalEnergy = 0;
+  m_totalTime = 0;
   m_output_power.Add (pos.x, atp);
   m_output.Add (pos.x, mbs);
   pos.x += stepsSize;
